<?php
if (!file_exists('config.php')) header("Location: setup.php");
require 'start.php'; // header stuff

// reconstruct the current url and put it in a cookie, so we can know where to come back to if we go off somewhere soon... but only save it for 15 minutes

if ($settings->dirurl != '') $currenturl = $settings->dirurl .'/index.php';
else $currenturl =  'http://' . $_SERVER['SERVER_NAME'] . $_SERVER['PHP_SELF'];
$currenturl .= '?'. $_SERVER['QUERY_STRING'];

if (($action != 'logout') && ($custom != 'yes') && ($TID != 'blank') && ($action != 'login'))
{
if (($currenturl != '')&&($_SERVER['PHP_SELF'] != '')&&($currenturl != '/?')&&($currenturl != 'http://?')&&($currenturl != 'http:///?'))
setcookie("returnto", "$currenturl",  900);
else
setcookie("returnto", "index.php",  900);
}
if ($action == 'setadminlocation')
{
setcookie("returnto", "index.php",  900);
$adminpath = "http://". $_SERVER['HTTP_HOST'] . dirname($_SERVER['PHP_SELF']);
if (dirname($_SERVER['PHP_SELF']) != '') $adminpath .= "/";
$adminpath .= $admindir .'/index.php?set=1';
header("Location: $adminpath"); 
}


// check to see if we should re-set something
$resetdelay = $settings->resetdelay * 86400; // convert from days to seconds
if ( (time() - $resetdelay) > $settings->resettime) 
{ 
 if ($settings->resetscript == ' ') $settings->resetscript = '';
 if ($settings->resetscript != '')
 {
  $settings->resettime = time();
  $settings->update('resettime');
  $ourinc = $settings->resetscript;
  include "$ourinc";
 }
}


$linkcolumns = 1;
if ($ascdesc != '') $orderlinks = 'ORDER BY '. $orderlinks .' '. $ascdesc;
if ($orderlinks == '')
{ // let user override value
 $orderlinks = $settings->orderlinks;
}
if ($perpage == '')
{ // let user override value
 $perpage = $settings->perpage;
}

if ($checkversion == 'docheck')
{
 echo 'WSN Guest version '. $version;
}
 
if ($page == '') $page = 1;

if (!$template) $template = new template('main.tpl');
$template->showwsncodes();
 
$area = $language->title_divider . $language->title_main; // supply area for template
 
$total = totalentries();

if ($total == 0)
{
 $template->replace('{LINKSBODY}', ''); 
}

$start = ($page * $perpage) - $perpage; // have to adjust for starting the numbering at 1
$end = $start + $perpage -1;

$linksbodybase = templateextract($template->text, "<!-- BEGIN ENTRIES -->", "<!-- END ENTRIES -->");
$template->replace($linksbodybase, '{LINKSBODY}'); // replace with marker

$begin = $start;
$end = $start + $perpage;
$toshow = $perpage;
if ( ($total == 0) || ($start >= $end) ) { $linksbodybase = ''; }
else
{ 
 $reglinksdata = entriesdata();
 for ($next=$start; ( ($next<$end) && ($next<$total) ); $next++)
 {
  // get next link
  $row = $db->row($reglinksdata);
  $thelink = new onelink('row', $row);
  $counter++;
  $links = $linksbodybase;
  // do replacements for single link
  if (($thelink->ownerid > 0) && (strstr($links, '{MEMBER'))) 
      $themem = new member('id', $thelink->ownerid);
  else
      $themem = new member('blank', 'blank');
  $thisaddition = memberreplacements(linkreplacements($links, $thelink), $themem);

  $template_linksbody .= $thisaddition;
  $thetotal++;
 }
}
  
if ($thetotal != 0) $template->replace('{LINKSBODY}', $template_linksbody);
else $template->replace('{LINKSBODY}', '');

if ($perpage < 1) $perpage = 1;
$numpages = ceil($total / $perpage);
$template->replace('{TOTALPAGES}', $numpages);
$sendorder = urlencode($orderlinks);
for ($count=1; $count < $page; $count++)
   $previouspages .= $language->pageselection_left. "<a href=index.php?page=$count&orderlinks=$sendorder&perpage=$perpage>$count</a>". $language->pageselection_right;
for ($count=$page; $count<$numpages; $count++)
{
   $next = $count+1;
   $nextpages .= $language->pageselection_left ."<a href=index.php?page=$next&orderlinks=$sendorder&perpage=$perpage>$next</a>". $language->pageselection_right;
}
$template->replace('{PREVIOUS}', $previouspages);
$template->replace('{NEXT}', $nextpages);
$template->replace('{CURRENTPAGE}', $page);
$template->replace('{PAGE}', $page);
$template->replace('{REORDER}', $reorder);
$template->replace('{PERPAGE}', $perpage);
$template->replace('{TOTALENTRIES}', $total); 
$template->replace('{START}', $begin + 1); 
if ($total < $end) $end = $total;
$template->replace('{END}', $end); 

require 'end.php';

?>